<template>
<div v-if="this.$store.getters.authenticatedUser">
    <b-container >
      <b-modal ref="my-modal" hide-footer title="Alert!">
      <div class="d-block text-center">
        <h6>This deployment will be permanently deleted. Are you sure you wish to delete it?</h6>
      </div>
      <div> <b-row>
        <b-col cols="2"></b-col>
        <b-col cols="4">
          <b-button class="mt-3" variant="danger" block @click="Continue">Yes</b-button>
        </b-col>
        <b-col cols="4">
          <b-button class="mt-3" variant="success" block @click="hideModal">No</b-button>
        </b-col>
      <b-col cols="2"></b-col>
      </b-row>
      </div>
    </b-modal>

    <b-modal ref="deleted-modal" hide-footer title="Confirmation message">
      <div class="d-block text-center">
        <h6>The deployment has been deleted!</h6>
      </div>
      <div> <b-row>
        <b-col cols="4"></b-col>
        <b-col cols="4">
          <router-link :to="{name: 'deployments'}">
          <b-button class="mt-3" variant="success" block @click="hideModal">Ok</b-button>
</router-link>
        </b-col>
      <b-col cols="4"></b-col>
      </b-row>
      </div>
    </b-modal>

       <div style ="min-height : 780px">
       <br>
           <b-col>
               <b-row  align-h="center"    > <h2  style="color : #22b574  " > {{this.deploymentDetails.name}} </h2>
               </b-row>
               <br>
               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3" ><h5 class="float-right">Type: </h5>
                   </b-col>
                   <b-col cols = "3"> <h5 class="float-left">{{ this.type}}</h5>
                   </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3" > <h5 class="float-right">Clearing:</h5>
                   </b-col>
                   <b-col cols = "3"> <h5 class="float-left">{{ this.ClearingOnView}}</h5>
                   </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3" ><h5 class="float-right">Entrypoint: </h5>
                   </b-col>
                   <b-col cols = "3"> <div>
  <b-link   target='_blank'  style="color : #22b574"  class="float-left" :href="deploymentDetails.url"><h5> {{ this.deploymentDetails.url}} </h5></b-link>
</div>
                   </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3" ><h5 class="float-right">API endpoint: </h5>
                   </b-col>
                   <b-col cols = "3">
                        <div>
  <b-link target='_blank' style="color : #22b574  "  class="float-left" :href="deploymentDetails.api_url"><h5> {{ this.deploymentDetails.api_url}} </h5></b-link>
</div>
                   </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3"><h5 class="float-right">Operator: </h5>
                   </b-col>
                   <b-col cols = "3"><h5 class="float-left"> {{ this.OperatorNameOnView}}</h5>
                   </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3"><h5 class="float-right">Region: </h5>
                   </b-col>
                   <b-col cols = "3"><h5 class="float-left">{{ this.regionDetails.country +" - "+ this.regionDetails.region +" - "+ this.regionDetails.city}}</h5>
                   </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3"><h5 class="float-right">Status: </h5>
                   </b-col>
                   <b-col cols = "3">
                   <b-button id="inactive"  class=" float-left" v-if="StatusButtonColor === 'red' "   variant="danger"  > <h5 class="float-right">
                        {{ this.deploymentDetails.status}}  </h5>
                   </b-button>
                   <b-button  id="active"    class="float-left" v-if="StatusButtonColor ===  'green' "  variant="success"  ><h5 class="float-right">
         {{ this.deploymentDetails.status}} </h5>
                   </b-button>
                   <b-button  id="pending"  class="float-left"  v-if="StatusButtonColor === 'yellow' "  variant="warning" ><h5 class="float-right">
          {{ this.deploymentDetails.status}}  </h5>
                   </b-button>
                   </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3"><h5 class="float-right">Contact Name: </h5>
                   </b-col>
                   <b-col cols = "3"><h5 class="float-left">{{ this.OperatorNameOnView}}</h5>
                    </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3"><h5 class="float-right">Contact Email: </h5>
                   </b-col>
                   <b-col cols = "3"> <h5 class="float-left">{{ this.OperatorEmail}}</h5>
                   </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>

               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3"><h5 class="float-right">Created: </h5>
                   </b-col>
                   <b-col cols = "3"> <h5 class="float-left">{{ this.localCreated}}</h5>
                   </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "3">
                   </b-col>
                   <b-col cols = "3"><h5 class="float-right">Updated: </h5>
                   </b-col>
                   <b-col cols = "3"><h5 class="float-left">{{ this.localUpdated}}</h5>
                   </b-col>
                   <b-col cols = "3">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "9">
                   </b-col>
                   <b-col cols = "2">
            <b-row>
                <b-col>
                    <b-row  align-h="end">               
                    <div id="deletebutton" @click="showDeleteModal"  @mouseover="mouseOver"  @mouseleave="mouseOut">
                <img v-if="HoverDelete"
                width="70%" src= "../assets/basketRecycleAtHover.png" >
                <img v-if="OutOfDelete"
                width="70%" src= "../assets/basketRecycle.png" >
                  </div>
       </b-row>
        </b-col>
      <b-col>
          <b-row align-h="start">
              <router-link :to="{name: 'deploymentAdd'}"   >
                  <div id="plusbutton" @mouseover="PlusmouseOver"  @mouseleave="PlusmouseOut">
                <img v-if="HoverPlus"
                width="70%" src= "../assets/PlusButtonAtHover.png" >
                <img v-if="OutOfPlus"
                width="70%" src= "../assets/PlusButton.png" >
                 </div>
                  </router-link>
                         </b-row>
                  </b-col>
                  </b-row>
                   </b-col>
                   <b-col cols = "1">
                       </b-col>
               </b-row>
            </b-col>
        </div>
    </b-container>
    </div>
<div v-else>
  <NoAccess></NoAccess>
  </div>
</template>
<script>
import moment from 'moment'
import NoAccess from '../components/NoAccess.vue'
import {mapGetters} from 'vuex'

export default {
  components: {NoAccess},
  beforeCreate () {
    console.log(this.$store.getters.authenticatedUser)
    if (this.$store.getters.authenticatedUser === false) {
      this.$router.push({name: 'home'})
    }
  },
  data () {
    return {
      deploymentDetails: [],
      regionDetails: [],
      ChopedUpdated: '',
      ChopedCreated: '',
      ClearingOnView: '',
      localUpdated: '',
      localCreated: '',
      type: '',
      OperatorNameOnView: '',
      StatusButtonColor: '',
      OperatorEmail: '',
      HoverDelete: false,
      OutOfDelete: true,
      HoverPlus: false,
      OutOfPlus: true
    }
  },
  computed: {
    ...mapGetters([
      'authenticatedUser'
    ]),
    user () {
      // get the fullname of the logged in user
      if (Object.keys(this.$store.state.user).length > 0) {
        return this.$store.state.user.name
      }
      return ''
    }
  },
  methods: {
    onLoad() {
      this.intervalId = setInterval(() => {
        //sending ajax request
        
this.$store.dispatch('getDeploymentById', this.$route.params.id)
      .then(response => {
       // console.log(response)
       // console.log(response.data)
       // console.trace(response.data)
       // console.table(response.data)
        this.$store.dispatch('getRegionById', response.data.region)
        .then(response => {
          console.log('response2')
         // console.log(response.data)
          this.regionDetails = response.data
        })
        .catch((error) => {
        console.info(error)
      }) 

        this.deploymentDetails = response.data

            
      if (this.deploymentDetails.status === 'pending') {
        this.StatusButtonColor = 'yellow' 
        console.log(this.StatusButtonColor)
      }
      if (this.deploymentDetails.status === 'inactive') {
        this.StatusButtonColor = 'red'
      }
      if (this.deploymentDetails.status === 'active') {
        this.StatusButtonColor = 'green'
      }
      })



      }, 5000)
    },
    

    deleteDeployment () {
      this.$store.dispatch('deleteDeployInView', this.$route.params.id)
        .then(response => {
          console.log("WTF")
          this.$refs['deleted-modal'].show()
         // this.$router.push({name: 'deployments'})
        }
        )
    },
    hideModal () {
         this.$refs['my-modal'].hide()
      },
    Continue () {
          this.deleteDeployment()
      },
     showDeleteModal () {
        console.log("Delete-modala")
        this.$refs['my-modal'].show()
        console.log("Delete-mod4343ala")
      }      
    ,
    mouseOver () {
      this.HoverDelete = true
      this.OutOfDelete = false
    },
    mouseOut () {
      this.HoverDelete = false
      this.OutOfDelete = true
    },
    PlusmouseOver () {
      this.HoverPlus = true
      this.OutOfPlus = false
    },
    PlusmouseOut () {
      this.HoverPlus = false
      this.OutOfPlus = true
    }
  },
  beforeDestroy() {
    clearInterval(this.intervalId)
  },

  mounted() {
            this.onLoad();
        } ,
  created: function () {
    // get the deployments
    this.$store.dispatch('getDeploymentById', this.$route.params.id)
      .then(response => {
        console.log(response)
      //  console.log(response.data)
     //   console.trace(response.data)
       // console.table(response.data)
        this.$store.dispatch('getRegionById', response.data.region)
        .then(response => {
          console.log('response2')
          console.log(response)
          this.regionDetails = response.data
        })
        .catch((error) => {
        console.info(error)
      }) 

        this.deploymentDetails = response.data
        if (this.deploymentDetails.flavour === 1) {
          console.log('Electricity')
          this.type = 'Electricity'
        }
        if (this.deploymentDetails.flavour === 2) {
          this.type = 'Flexibility'
        }
        if (this.deploymentDetails.flavour === 3) {
          this.type = 'Heat'
        }
        if (this.deploymentDetails.flavour === 4) {
          this.type = 'IT-load'
        }
        if (this.deploymentDetails.status === 'pending') {
          this.StatusButtonColor = 'yellow'
        }
        if (this.deploymentDetails.status === 'inactive') {
          this.StatusButtonColor = 'red'
        }
        if (this.deploymentDetails.status === 'active') {
          this.StatusButtonColor = 'green'
        }
        if (this.deploymentDetails.clearing === 1) {
          this.ClearingOnView = 'Based on Market Equilibrium'
        }

        if (this.deploymentDetails.clearing === 2) {
          this.ClearingOnView = 'Selective'
        }

        if (this.deploymentDetails.clearing === 3) {
          this.ClearingOnView = 'Based on Best-fit'
        }
        this.ChopedUpdated = this.deploymentDetails.updated_at.slice(0, -8).replace('T', ' ')
        this.localUpdated = moment.utc(this.ChopedUpdated).format('YYYY-MM-DD HH:mm:ss')
        this.ChopedCreated = this.deploymentDetails.created_at.slice(0, -8).replace('T', ' ')
        this.localCreated = moment.utc(this.ChopedCreated).format('YYYY-MM-DD HH:mm:ss')
        this.$store.dispatch('getOperatorByIdForDeployView', this.deploymentDetails.operator)
          .then(response => {
            this.OperatorNameOnView = response.data.name
            this.OperatorEmail = response.data.email
          })
      })
  }
}
</script>

<style scoped>

</style>
<style >

#pending  {
     background-color : #f1f22a !important ;
     color : #555555 !important ;
     padding-top : 0.01rem !important;
     padding-bottom : 0.01rem !important ;
     border : 0px;
     cursor: not-allowed !important ;
     pointer-events: none !important;
      }

#active {
     background-color :#22b574 !important ;
     color : white !important ;
     padding-top : 0.01rem !important;
     padding-bottom : 0.01rem !important ;
     cursor: not-allowed !important ;
        pointer-events: none !important;
      }

#inactive {
     background-color : #f26076  !important ;
     color : white !important ;
     padding-top : 0.01rem !important;
     padding-bottom : 0.01rem !important  ;
     cursor: not-allowed !important ;
        pointer-events: none !important;
      }

#deletebutton  {
    text-align : right;
}
#plusbutton  {
    text-align : left;
}
</style>
